class InitResultModel {
  final bool status;
  final int code;
  final String msg;

  InitResultModel(this.status, this.code, this.msg);

  Map toMap() {
    return {"status": status, "code": code, "msg": msg};
  }
}

class LoginResultModel {
  final bool status;
  final int code;
  final String msg;
  final UserInfoResultModel userInfo;

  LoginResultModel(this.status, this.code, this.msg, this.userInfo);

  Map toMap() {
    return {"status": status, "code": code, "msg": msg, "userInfo": userInfo};
  }
}

class UserInfoResultModel {
  final String userId;
  final String userNick;
  UserInfoResultModel(this.userId, this.userNick);
  Map toMap() {
    return {"userId": userId, "userNick": userNick};
  }
}

class OpenResultModel {
  final bool status;
  final int code;
  final String msg;

  OpenResultModel(this.status, this.code, this.msg);
  Map toMap() {
    return {"status": status, "code": code, "msg": msg};
  }
}

class IsLoginResultModel {
  final bool status;
  final String msg;
  final bool isLogin;
  IsLoginResultModel(this.status, this.msg, this.isLogin);
  Map toMap() {
    return {"status": status, "isLogin": isLogin, "msg": msg};
  }
}

class GetUserInfoResultModel {
  final bool status;
  final int code;
  final String msg;
  final UserInfoResultModel userInfo;

  GetUserInfoResultModel(this.status, this.code, this.msg, this.userInfo);
  Map toMap() {
    return {"status": status, "code": code, "msg": msg, "userInfo": userInfo};
  }
}
